#pragma once
#include "Thing.h"
#include "Header.h"

class barriers : public Thing
{
private:
	//SDL_Rect BarrierTarget[i][i];
	//SDL_Rect *barrierRect;
	bool destroyed = false;
	SDL_bool collides;
	int i;
	int u;
	int v;
	int z;
public:
	virtual	void initiate(int i) {
		BarrierTarget[i].w = 10; BarrierTarget[i].h = 10;
		barrierSource.y = (stage-1)*10;
		destroyed = false;
		//first barrier (from left) 
		if (i < 25) { //left base 5*5 squares
			if (i < 5) {
				BarrierTarget[i].x = 80 + (i * 10); BarrierTarget[i].y = 520;
			}
			else if (i < 10) {
				BarrierTarget[i].x = 80 + ((i - 5) * 10); BarrierTarget[i].y = 520 - 10;
			}
			else if (i < 15) {
				BarrierTarget[i].x = 80 + ((i - 10) * 10); BarrierTarget[i].y = 520 - 20;
			}
			else if (i < 20) {
				BarrierTarget[i].x = 80 + ((i - 15) * 10); BarrierTarget[i].y = 520 - 30;
			}
			else {
				BarrierTarget[i].x = 80 + ((i - 20) * 10); BarrierTarget[i].y = 520 - 40;
			}
		}
		else if (i < 50) {//right base 5*5 squares
			if (i < 30) {
				BarrierTarget[i].x = 180 + ((i - 25) * 10); BarrierTarget[i].y = 520;
			}
			else if (i < 35) {
				BarrierTarget[i].x = 180 + ((i - 30) * 10); BarrierTarget[i].y = 520 - 10;
			}
			else if (i < 40) {
				BarrierTarget[i].x = 180 + ((i - 35) * 10); BarrierTarget[i].y = 520 - 20;
			}
			else if (i < 45) {
				BarrierTarget[i].x = 180 + ((i - 40) * 10); BarrierTarget[i].y = 520 - 30;
			}
			else {
				BarrierTarget[i].x = 180 + ((i - 45) * 10); BarrierTarget[i].y = 520 - 40;
			}
		}
		else if (i < 63) {//pyramid on top
			BarrierTarget[i].x = 90 + ((i - 50) * 10); BarrierTarget[i].y = 470;
		}
		else if (i < 74) {
			BarrierTarget[i].x = 100 + ((i - 63) * 10); BarrierTarget[i].y = 470 - 10;
		}
		else if (i < 83) {
			BarrierTarget[i].x = 110 + ((i - 74) * 10); BarrierTarget[i].y = 470 - 20;
		}
		else if (i < 90) {
			BarrierTarget[i].x = 120 + ((i - 83) * 10); BarrierTarget[i].y = 470 - 30;
		}
		else if (i < 95) {
			BarrierTarget[i].x = 130 + ((i - 90) * 10); BarrierTarget[i].y = 470 - 40;
		}
		//2nd barrier
		else if (i < 120) {
			if (i < 100) {
				BarrierTarget[i].x = 310 + ((i - 95) * 10); BarrierTarget[i].y = 520;
			}
			else if (i < 105) {
				BarrierTarget[i].x = 310 + ((i - 100) * 10); BarrierTarget[i].y = 520 - 10;
			}
			else if (i < 110) {
				BarrierTarget[i].x = 310 + ((i - 105) * 10); BarrierTarget[i].y = 520 - 20;
			}
			else if (i < 115) {
				BarrierTarget[i].x = 310 + ((i - 110) * 10); BarrierTarget[i].y = 520 - 30;
			}
			else {
				BarrierTarget[i].x = 310 + ((i - 115) * 10); BarrierTarget[i].y = 520 - 40;
			}
		}
		else if (i < 145) {
			if (i < 125) {
				BarrierTarget[i].x = 410 + ((i - 120) * 10); BarrierTarget[i].y = 520;
			}
			else if (i < 130) {
				BarrierTarget[i].x = 410 + ((i - 125) * 10); BarrierTarget[i].y = 520 - 10;
			}
			else if (i < 135) {
				BarrierTarget[i].x = 410 + ((i - 130) * 10); BarrierTarget[i].y = 520 - 20;
			}
			else if (i < 140) {
				BarrierTarget[i].x = 410 + ((i - 135) * 10); BarrierTarget[i].y = 520 - 30;
			}
			else {
				BarrierTarget[i].x = 410 + ((i - 140) * 10); BarrierTarget[i].y = 520 - 40;
			}
		}
		else if (i < 158) {
			BarrierTarget[i].x = 320 + ((i - 145) * 10); BarrierTarget[i].y = 470;
		}
		else if (i < 169) {
			BarrierTarget[i].x = 330 + ((i - 158) * 10); BarrierTarget[i].y = 470 - 10;
		}
		else if (i < 178) {
			BarrierTarget[i].x = 340 + ((i - 169) * 10); BarrierTarget[i].y = 470 - 20;
		}
		else if (i < 185) {
			BarrierTarget[i].x = 350 + ((i - 178) * 10); BarrierTarget[i].y = 470 - 30;
		}
		else if (i < 190) {
			BarrierTarget[i].x = 360 + ((i - 185) * 10); BarrierTarget[i].y = 470 - 40;
		}

		//3rd barrier
		else if (i < 215) {
			if (i < 195) {
				BarrierTarget[i].x = 540 + ((i - 190) * 10); BarrierTarget[i].y = 520;
			}
			else if (i < 200) {
				BarrierTarget[i].x = 540 + ((i - 195) * 10); BarrierTarget[i].y = 520 - 10;
			}
			else if (i < 205) {
				BarrierTarget[i].x = 540 + ((i - 200) * 10); BarrierTarget[i].y = 520 - 20;
			}
			else if (i < 210) {
				BarrierTarget[i].x = 540 + ((i - 205) * 10); BarrierTarget[i].y = 520 - 30;
			}
			else {
				BarrierTarget[i].x = 540 + ((i - 210) * 10); BarrierTarget[i].y = 520 - 40;
			}
		}
		else if (i < 240) {
			if (i < 220) {
				BarrierTarget[i].x = 640 + ((i - 215) * 10); BarrierTarget[i].y = 520;
			}
			else if (i < 225) {
				BarrierTarget[i].x = 640 + ((i - 220) * 10); BarrierTarget[i].y = 520 - 10;
			}
			else if (i < 230) {
				BarrierTarget[i].x = 640 + ((i - 225) * 10); BarrierTarget[i].y = 520 - 20;
			}
			else if (i < 235) {
				BarrierTarget[i].x = 640 + ((i - 230) * 10); BarrierTarget[i].y = 520 - 30;
			}
			else {
				BarrierTarget[i].x = 640 + ((i - 235) * 10); BarrierTarget[i].y = 520 - 40;
			}
		}
		else if (i < 253) {
			BarrierTarget[i].x = 550 + ((i - 240) * 10); BarrierTarget[i].y = 470;
		}
		else if (i < 264) {
			BarrierTarget[i].x = 560 + ((i - 253) * 10); BarrierTarget[i].y = 470 - 10;
		}
		else if (i < 273) {
			BarrierTarget[i].x = 570 + ((i - 264) * 10); BarrierTarget[i].y = 470 - 20;
		}
		else if (i < 280) {
			BarrierTarget[i].x = 580 + ((i - 273) * 10); BarrierTarget[i].y = 470 - 30;
		}
		else if (i < 285) {
			BarrierTarget[i].x = 590 + ((i - 280) * 10); BarrierTarget[i].y = 470 - 40;
		}
		//4th barrier
		else if (i < 310) {
			if (i < 290) {
				BarrierTarget[i].x = 770 + ((i - 285) * 10); BarrierTarget[i].y = 520;
			}
			else if (i < 295) {
				BarrierTarget[i].x = 770 + ((i - 290) * 10); BarrierTarget[i].y = 520 - 10;
			}
			else if (i < 300) {
				BarrierTarget[i].x = 770 + ((i - 295) * 10); BarrierTarget[i].y = 520 - 20;
			}
			else if (i < 305) {
				BarrierTarget[i].x = 770 + ((i - 300) * 10); BarrierTarget[i].y = 520 - 30;
			}
			else {
				BarrierTarget[i].x = 770 + ((i - 305) * 10); BarrierTarget[i].y = 520 - 40;
			}
		}
		else if (i < 335) {
			if (i < 315) {
				BarrierTarget[i].x = 870 + ((i - 310) * 10); BarrierTarget[i].y = 520;
			}
			else if (i < 320) {
				BarrierTarget[i].x = 870 + ((i - 315) * 10); BarrierTarget[i].y = 520 - 10;
			}
			else if (i < 325) {
				BarrierTarget[i].x = 870 + ((i - 320) * 10); BarrierTarget[i].y = 520 - 20;
			}
			else if (i < 330) {
				BarrierTarget[i].x = 870 + ((i - 325) * 10); BarrierTarget[i].y = 520 - 30;
			}
			else {
				BarrierTarget[i].x = 870 + ((i - 330) * 10); BarrierTarget[i].y = 520 - 40;
			}
		}
		else if (i < 348) {
			BarrierTarget[i].x = 780 + ((i - 335) * 10); BarrierTarget[i].y = 470;
		}
		else if (i < 359) {
			BarrierTarget[i].x = 790 + ((i - 348) * 10); BarrierTarget[i].y = 470 - 10;
		}
		else if (i < 368) {
			BarrierTarget[i].x = 800 + ((i - 359) * 10); BarrierTarget[i].y = 470 - 20;
		}
		else if (i < 375) {
			BarrierTarget[i].x = 810 + ((i - 368) * 10); BarrierTarget[i].y = 470 - 30;
		}
		else if (i < 380) {
			BarrierTarget[i].x = 820 + ((i - 375) * 10); BarrierTarget[i].y = 470 - 40;
		}
		//globalBarrierRect[i] = BarrierTarget[i];
	}
	virtual void update(int i)
	{
		if (destroyed == false) {
			collides = SDL_HasIntersection(&BarrierTarget[i], &PlayerLaserRect);
			if (collides == SDL_TRUE) { //HIT BY PLAYER LASER?
				destroyed = true;
				PlayerlaserCollide = true;
				PlayershotFired = false;
				PlayerLaserRect.x = 0; PlayerLaserRect.y = 0;
				u = i * 4;
				fragmentActive[u] = true; fragmentActive[u + 1] = true; fragmentActive[u + 2] = true; fragmentActive[u + 3] = true;
				collides = SDL_FALSE;
				for (z = 0; z < 32; z++) {
					if (FX_QUEUE[z] == SILENCE_PUSH) {
						FX_QUEUE[z] = BARRIEREXPLOSION_PUSH;
						break;
					}
				}
				
				
			}
			for (u = 0; u < 55; u++) { //HIT BY ENEMY LASER?
				collides = SDL_HasIntersection(&BarrierTarget[i], &enemyLaserRect[u]);
				if (collides == SDL_TRUE){
					destroyed = true;
					enemyLaserActive[u] = false;
					enemyLaserRect[u].x = 0; enemyLaserRect[u].y = 0;
					v = i * 4;
					fragmentActive[v] = true; fragmentActive[v + 1] = true; fragmentActive[v + 2] = true; fragmentActive[v + 3] = true;
					collides = SDL_FALSE;
					for (z = 0; z < 32; z++) {
						if (FX_QUEUE[z] == SILENCE_PUSH) {
							FX_QUEUE[z] = BARRIEREXPLOSION_PUSH;
							break;
						}
					}
				}
			}
			for (u = 1520; u < 1810; u++) { //HIT BY FRAGMENTS COMING FROM EXPLODING ENEMIES?
					collides = SDL_HasIntersection(&BarrierTarget[i], &FragmentTarget[u]);
					if (collides == SDL_TRUE) {
						destroyed = true;
						v = i * 4;
						fragmentActive[v] = true; fragmentActive[v + 1] = true; fragmentActive[v + 2] = true; fragmentActive[v + 3] = true;
						collides = SDL_FALSE;
						fragmentActive[u] = false;
						FragmentTarget[u].x = 0; FragmentTarget[u].y = 0;
						for (z = 0; z < 32; z++) {
							if (FX_QUEUE[z] == SILENCE_PUSH) {
								FX_QUEUE[z] = BARRIEREXPLOSION_PUSH;
								break;
							}
						}
					}
				}
			}

		if (destroyed == false && GlobalReset == false) {
				SDL_RenderCopy(renderer, barrierTexture, &barrierSource, &BarrierTarget[i]);
				while (true) {
					for (i = 0; i < 22; i++) {
						collides = SDL_HasIntersection(&BarrierTarget[i], &takoTarget[i]);
						if (collides == SDL_TRUE) {
							Globalgameover = true;;
							break;
						}
					}
					for (i = 0; i < 22; i++) {
						collides = SDL_HasIntersection(&BarrierTarget[i], &tripodBodyTarget[i]);
						if (collides == SDL_TRUE) {
							Globalgameover = true;;
							break;
						}
					}
					for (i = 0; i < 11; i++) {
						collides = SDL_HasIntersection(&BarrierTarget[i], &littleGreyTarget[i]);
						if (collides == SDL_TRUE) {
							Globalgameover = true;;
							break;
						}
					}
					break;
				}
			}
		}
	
	barriers()
	{
	}

	~barriers()
	{
	}
};

