#pragma once
#include "Thing.h"
#include "Header.h"
class pause :
	public Thing
{
private:
	SDL_Surface *pauseSurface;
	SDL_Rect pauseTarget;
	SDL_Texture * pauseTexture;
	SDL_Color textColor;
	bool pausing;
public:
	virtual void initiate(int i) {
		SDL_FreeSurface(pauseSurface);
		SDL_DestroyTexture(pauseTexture);
		textColor = { 255, 255, 255 };
		pauseSurface = TTF_RenderText_Solid(font, "PAUSE", textColor);
		pauseTexture = SDL_CreateTextureFromSurface(renderer, pauseSurface);
		pauseTarget.x = 350; pauseTarget.y = 300; pauseTarget.h = 80; pauseTarget.w = 200;
	}
	virtual void update(int i) {
		if (Pause == true) {
			SDL_RenderCopy(renderer, pauseTexture, NULL, &pauseTarget);
			SDL_RenderPresent(renderer);
			pausing = true;
			SDL_SetRelativeMouseMode(SDL_FALSE);
			while (pausing == true && game == true) {
				while (SDL_PollEvent(&event) != 0) {
					switch (event.type)
					{
					case SDL_KEYDOWN:
						switch (event.key.keysym.sym) {
						case SDLK_p:
							pausing = false;
							break;
						}
						break;
					}
				}
			}
			Pause = false;
			SDL_SetRelativeMouseMode(SDL_TRUE);
		}
	}
	virtual void destroy(int i) {
		SDL_FreeSurface(pauseSurface);
		SDL_DestroyTexture(pauseTexture);
	}
	pause()
	{
	}

	~pause()
	{
	}
};

