#pragma once
#include "Thing.h"
#include "Header.h"

class tripod :
	public Thing
{
private:
	SDL_Rect tripodBodySource;
	//SDL_Rect tripodBodyTarget;
	//bool firstLaser = true;
	bool shooting = false;
	//int tripodFrame = 0;
	bool leftLegMove = true;
	bool middleLegMove = false;
	bool rightLegMove = false;
	int leftLegStartX;
	int leftLegStartY;
	int leftLegEndX;
	int leftLegEndY;
	int middleLegStartX;
	int middleLegStartY;
	int middleLegEndX;
	int middleLegEndY;
	int rightLegStartX;
	int rightLegStartY;
	int rightLegEndX;
	int rightLegEndY;
	SDL_bool collides;
	int i;
	int u;
	int z;
	int zuffi;

public:
	bool front = false;
	bool dead = false;

	virtual void initiate(int i) {
		shooting = false;
		collides = SDL_FALSE;
		dead = false;
		front = false;
		leftLegMove = true;
		middleLegMove = false;
		rightLegMove = false;
		tripodBodySource.x = 0; tripodBodySource.y = (stage-1)*28; tripodBodySource.w = 50; tripodBodySource.h = 28;
		tripodBodyTarget[i-392].w = 50; tripodBodyTarget[i - 392].h = 28;
		if ((i-392) < 11) { tripodBodyTarget[i - 392].x = 70 + ((i-392) * 65); tripodBodyTarget[i - 392].y = 105 + levelup; }
		else {tripodBodyTarget[i - 392].x = 70 + (((i-392) - 11) * 65); tripodBodyTarget[i - 392].y = 105 + 65 + levelup; }
		
		leftLegStartX = tripodBodyTarget[i - 392].x + 11; leftLegStartY = tripodBodyTarget[i - 392].h + tripodBodyTarget[i - 392].y;
		LegStartX[(i - 392)*3] = leftLegStartX;
		LegStartY[(i - 392) * 3] = leftLegStartY;
		leftLegEndX = tripodBodyTarget[i - 392].x + 5; leftLegEndY = tripodBodyTarget[i - 392].h + 32 + tripodBodyTarget[i - 392].y;
		LegEndX[(i - 392) * 3] = leftLegEndX;
		LegEndY[(i - 392) * 3] = leftLegEndY;

		middleLegStartX = tripodBodyTarget[i - 392].x + 23; middleLegStartY = tripodBodyTarget[i - 392].h + tripodBodyTarget[i - 392].y;
		LegStartX[((i - 392) * 3) + 1] = middleLegStartX;
		LegStartY[((i - 392) * 3) + 1] = middleLegStartY;
		middleLegEndX = tripodBodyTarget[i - 392].x + 23; middleLegEndY = tripodBodyTarget[i - 392].h + 32 + tripodBodyTarget[i - 392].y;
		LegEndX[((i - 392) * 3) + 1] = middleLegEndX;
		LegEndY[((i - 392) * 3) + 1] = middleLegEndY;

		rightLegStartX = tripodBodyTarget[i - 392].x + 37; rightLegStartY = tripodBodyTarget[i - 392].h + tripodBodyTarget[i - 392].y;
		LegStartX[((i - 392) * 3) + 2] = rightLegStartX;
		LegStartY[((i - 392) * 3) + 2] = rightLegStartY;
		rightLegEndX = tripodBodyTarget[i - 392].x + 44; rightLegEndY = tripodBodyTarget[i - 392].h + 32 + tripodBodyTarget[i - 392].y;
		LegEndX[((i - 392) * 3) + 2] = rightLegEndX;
		LegEndY[((i - 392) * 3) + 2] = rightLegEndY;

		//tripodBodyTarget[i - 392].h = tripodBodyTarget[i - 392].h + 32;
		//tripodRect[i-392] = tripodBodyTarget; tripodBodyTarget[i - 392].h = tripodBodyTarget.h - 32;//post full size including legs for collision checking
	}

	virtual void update(int i) {
		if (dead == false) {
			if (go == true) {
				if (left == true) {
					tripodBodyTarget[i - 392].x = tripodBodyTarget[i - 392].x - 10;
					//tripodRect[i - 392] = tripodBodyTarget;
				}
				else if (right == true) {
					tripodBodyTarget[i - 392].x = tripodBodyTarget[i - 392].x + 10;
					//tripodRect[i - 392] = tripodBodyTarget;
				}
				else if (down == true) {
					tripodBodyTarget[i - 392].y = tripodBodyTarget[i - 392].y + 16;
					//tripodRect[i - 392] = tripodBodyTarget;
					wentDown = true;
				}
				collides = SDL_HasIntersection(&tripodBodyTarget[i - 392], &LeftBorder);
				if (collides == SDL_TRUE && wentDown == false) {
					nextDownthenRight = true;
				}
				collides = SDL_HasIntersection(&tripodBodyTarget[i - 392], &RightBorder);
				if (collides == SDL_TRUE && wentDown == false) {
					nextDownthenLeft = true;
				}
				//tripodRect[i - 392] = tripodBodyTarget;
				u = ((i - 392) * 4) + 1674;
				FragmentTarget[u].x = tripodBodyTarget[i - 392].x; FragmentTarget[u].y = tripodBodyTarget[i - 392].y;//top Left
				FragmentTarget[u + 1].x = tripodBodyTarget[i - 392].x + 25; FragmentTarget[u + 1].y = tripodBodyTarget[i - 392].y;//top Right
				FragmentTarget[u + 2].x = tripodBodyTarget[i - 392].x; FragmentTarget[u + 2].y = tripodBodyTarget[i - 392].y + 14;//middle Left
				FragmentTarget[u + 3].x = tripodBodyTarget[i - 392].x + 25; FragmentTarget[u + 3].y = tripodBodyTarget[i - 392].y + 14;//middle Right
				
				leftLegStartX = tripodBodyTarget[i - 392].x + 11;
				leftLegStartY = tripodBodyTarget[i - 392].h + tripodBodyTarget[i - 392].y;
				leftLegEndX = tripodBodyTarget[i - 392].x + 5;
				leftLegEndY = tripodBodyTarget[i - 392].h + 32 + tripodBodyTarget[i - 392].y;
				
				middleLegStartX = tripodBodyTarget[i - 392].x + 23;;
				middleLegStartY = tripodBodyTarget[i - 392].h + tripodBodyTarget[i - 392].y;
				middleLegEndX = tripodBodyTarget[i - 392].x + 23;
				middleLegEndY = tripodBodyTarget[i - 392].h + 32 + tripodBodyTarget[i - 392].y;
								
				rightLegStartX = tripodBodyTarget[i - 392].x + 37;;
				rightLegStartY = tripodBodyTarget[i - 392].h + tripodBodyTarget[i - 392].y;
				rightLegEndX = tripodBodyTarget[i - 392].x + 44;
				rightLegEndY = tripodBodyTarget[i - 392].h + 32 + tripodBodyTarget[i - 392].y;

				while (true) {
					if (leftLegMove == true) {
						leftLegEndX = leftLegEndX + 5;
						leftLegMove = false;
						middleLegMove = true;
						break;
					}
					else if (middleLegMove == true) {
						middleLegEndX = middleLegEndX + 5;
						middleLegMove = false;
						rightLegMove = true;
						break;
					}
					else if (rightLegMove == true) {
						rightLegEndX = rightLegEndX + 5;
						rightLegMove = false;
						leftLegMove = true;
						break;
					}
				}
				u = ((i - 392) * 3);
				LegStartX[u] = leftLegStartX;
				LegEndX[u] = leftLegEndX;
				LegStartY[u] = leftLegStartY;
				LegEndY[u] = leftLegEndY;
			
				LegStartX[u + 1] = middleLegStartX;
				LegEndX[u + 1] = middleLegEndX;
				LegStartY[u + 1] = middleLegStartY;
				LegEndY[u + 1] = middleLegEndY;
				
				LegStartX[u + 2] = rightLegStartX;
				LegEndX[u + 2] = rightLegEndX;
				LegStartY[u + 2] = rightLegStartY;
				LegEndY[u + 2] = rightLegEndY;
			}
			tripodBodyTarget[i - 392].h = tripodBodyTarget[i - 392].h + 32;
			collides = SDL_HasIntersection(&tripodBodyTarget[i - 392], &PlayerLaserRect);
			if (collides == SDL_TRUE) {
				dead = true; 
				score = score + 20;
				EnemiesLeft = EnemiesLeft - 1; //change something
				PlayerlaserCollide = true;
				PlayershotFired = false;
				PlayerLaserRect.x = 0;
				PlayerLaserRect.y = 0;
				moveTreshold = moveTreshold - 9000000;
				explosionActive[i - 381] = true;
				explosionTarget[i - 381] = tripodBodyTarget[i - 392];
				u = ((i - 392) * 3) + 1608; //legs
				fragmentActive[u] = true; fragmentActive[u + 1] = true; fragmentActive[u + 2] = true; 
				u = ((i - 392) * 4) + 1674; //body
				fragmentActive[u] = true; fragmentActive[u + 1] = true; fragmentActive[u + 2] = true; fragmentActive[u + 3] = true;
				for (z = 0; z < 32; z++) {
					if (FX_QUEUE[z] == SILENCE_PUSH) {
						FX_QUEUE[z] = ENEMYEXPLOSION_PUSH;
						break;
					}
				}
			}
			if (dead == false) {
				if (enemyLaserActive[i - 392] == false) shooting = false;
				tripodBodyTarget[i - 392].h = tripodBodyTarget[i - 392].h - 32;
				//tripodRect[i - 392] = tripodBodyTarget;
				if (dead == false && front == true && shooting == false) {
					srand(SDL_GetTicks()*(SDL_GetTicks()*(time(NULL))*time(NULL)));
					zuffi = rand() % 200 + 1;
					if (zuffi == i - 390) {
						enemyLaserActive[i - 392] = true;
						enemyLaserStartX[i - 392] = tripodBodyTarget[i - 392].x + 25; enemyLaserEndX[i - 392] = enemyLaserStartX[i - 392];
						enemyLaserStartY[i - 392] = tripodBodyTarget[i - 392].y + 28; enemyLaserEndY[i - 392] = tripodBodyTarget[i - 392].y + 28;
						enemyLaserRect[i - 392].x = enemyLaserStartX[i - 392]; enemyLaserRect[i - 392].y = enemyLaserStartY[i - 392]; enemyLaserRect[i - 392].w = 3; enemyLaserRect[i - 392].h = 20;
						shooting = true; enemyLaserActive[i - 392] = true;
					}
				}
				SDL_RenderCopy(renderer, tripodBodyTexture, &tripodBodySource, &tripodBodyTarget[i - 392]);
				SDL_SetRenderDrawColor(renderer, 255, 255, 255, 255);
				for (i = 0; i < 2; i++) {
					SDL_RenderDrawLine(renderer, leftLegStartX + i, leftLegStartY, leftLegEndX + i, leftLegEndY);
				}
				for (i = 0; i < 2; i++) {
					SDL_RenderDrawLine(renderer, middleLegStartX + i, middleLegStartY, middleLegEndX + i, middleLegEndY);
				}
				for (i = 0; i < 2; i++) {
					SDL_RenderDrawLine(renderer, rightLegStartX + i, rightLegStartY, rightLegEndX + i, rightLegEndY);
				}
			}
		}
	}

	tripod()
	{
	}

	~tripod()
	{
	}
};

