#pragma once
#include "Thing.h"
#include "Header.h"


class Score:
	public Thing
{
private:
	SDL_Surface *score;
	SDL_Rect ScoreTarget;
	SDL_Texture * ScoreTexture;
	SDL_Color textColor;
public:
	
	virtual void initiate(int i) {
		SDL_FreeSurface(score);
		SDL_DestroyTexture(ScoreTexture);
		textColor = { 255, 255, 255 };
		score = TTF_RenderText_Solid(font, "SCORE : ", textColor);
		ScoreTexture = SDL_CreateTextureFromSurface(renderer, score);
		ScoreTarget.x = 10; ScoreTarget.y = 10; ScoreTarget.h = 20; ScoreTarget.w = 80;
	}
	virtual void update(int i) {
		SDL_RenderCopy(renderer, ScoreTexture, NULL, &ScoreTarget);
	}
	virtual void destroy(int i) {
		SDL_FreeSurface(score);
		SDL_DestroyTexture(ScoreTexture);
	}
	Score()
	{
	}

	~Score()
	{
	}
};

