#pragma once
#include "Thing.h"
#include "Header.h"

class littleGrey :
	public Thing
{
private:
	SDL_Rect littleGreySource;
	//SDL_Rect littleGreyTarget;
	bool firstLaser = true;
	bool shooting = false;
	int littleGreyFrame = 0;
	SDL_bool collides;
	int i;
	int u;
	int zuffi;
	int z;
public:
	bool front = false;
	bool dead = false;
	virtual void initiate(int i) {
		collides = SDL_FALSE;
		shooting = false;
		littleGreyFrame = 0;
		dead = false;
		front = false;
		littleGreySource.x = 0; littleGreySource.y = 0 + ((stage - 1) * 60); littleGreySource.w = 50; littleGreySource.h = 60;
		littleGreyTarget[i - 381].x = 70 + ((i - 381) * 65); littleGreyTarget[i - 381].y = 35 + levelup; littleGreyTarget[i - 381].w = 50; littleGreyTarget[i - 381].h = 60;
		//littleGreyRect[i-381] = littleGreyTarget;
		littleGreyDead[i - 381] = false;
	}
	virtual void update(int i) {
		if (dead == false) {
			if (go == true) {
				if (littleGreyFrame == 0) littleGreyFrame = 1;
				else littleGreyFrame = 0;
				if (littleGreyFrame == 0)
					littleGreySource.x = 0;
				else
					littleGreySource.x = 50;
				if (left == true)	littleGreyTarget[i - 381].x = littleGreyTarget[i - 381].x - 10;
				else if (right == true)	littleGreyTarget[i - 381].x = littleGreyTarget[i - 381].x + 10;
				else if (down == true){
					littleGreyTarget[i - 381].y = littleGreyTarget[i - 381].y + 16;
					wentDown = true;
				}
				collides = SDL_HasIntersection(&littleGreyTarget[i - 381], &LeftBorder);
				if (collides == SDL_TRUE && wentDown == false) {
					nextDownthenRight = true;
				}
				collides = SDL_HasIntersection(&littleGreyTarget[i - 381], &RightBorder);
				if (collides == SDL_TRUE && wentDown == false) {
					nextDownthenLeft = true;
				}
				
				//littleGreyRect[i - 381] = littleGreyTarget;
				u = ((i - 381) * 4) + 1762;
				FragmentTarget[u].x = littleGreyTarget[i - 381].x; FragmentTarget[u].y = littleGreyTarget[i - 381].y;//top Left
				FragmentTarget[u + 1].x = littleGreyTarget[i - 381].x + 25; FragmentTarget[u + 1].y = littleGreyTarget[i - 381].y;//top Right
				FragmentTarget[u + 2].x = littleGreyTarget[i - 381].x; FragmentTarget[u + 2].y = littleGreyTarget[i - 381].y + 30;//bottom Left
				FragmentTarget[u + 3].x = littleGreyTarget[i - 381].x + 25; FragmentTarget[u + 3].y = littleGreyTarget[i - 381].y + 30;//bottom Right
			}
			collides = SDL_HasIntersection(&littleGreyTarget[i - 381], &PlayerLaserRect);
			if (collides == SDL_TRUE) {
				dead = true;
				littleGreyDead[i - 381] = true;
				score = score + 30;
				EnemiesLeft = EnemiesLeft - 1;
				PlayerlaserCollide = true;
				PlayershotFired = false;
				PlayerLaserRect.x = 0;
				PlayerLaserRect.y = 0;
				//littleGreyTarget[i - 381] = littleGreyTarget;
				moveTreshold = moveTreshold - 9000000;
				explosionActive[i - 381] = true;
				explosionTarget[i - 381] = littleGreyTarget[i - 381];
				u = ((i - 381) * 4) + 1762;
				fragmentActive[u] = true; fragmentActive[u + 1] = true; fragmentActive[u + 2] = true; fragmentActive[u + 3] = true;
				for (z = 0; z < 32; z++) {
					if (FX_QUEUE[z] == SILENCE_PUSH) {
						FX_QUEUE[z] = ENEMYEXPLOSION_PUSH;
						break;
					}
				}
			}
			if (dead == false) {
				if (enemyLaserActive[i - 381] == false) shooting = false;
				if (front == true && shooting == false) {
					srand(SDL_GetTicks()*(SDL_GetTicks()*(time(NULL))*time(NULL)));
					zuffi = rand() % 200 + 1;
					if (zuffi == i - 380) {
						enemyLaserActive[i - 381] = true;
						enemyLaserStartX[i - 381] = littleGreyTarget[i - 381].x + 25; enemyLaserEndX[i - 381] = enemyLaserStartX[i - 381];
						enemyLaserStartY[i - 381] = littleGreyTarget[i - 381].y + 40; enemyLaserEndY[i - 381] = littleGreyTarget[i - 381].y + 40;
						enemyLaserRect[i - 381].x = enemyLaserStartX[i - 381]; enemyLaserRect[i - 381].y = enemyLaserStartY[i - 381]; enemyLaserRect[i - 381].w = 3; enemyLaserRect[i - 381].h = 20;
						shooting = true; enemyLaserActive[i - 381] = true;
					}
				}
			}
			SDL_RenderCopy(renderer, littleGreyTexture, &littleGreySource, &littleGreyTarget[i - 381]);
		}
		//littleGreyTarget[i - 381] = littleGreyTarget;
	}
	
	littleGrey()
	{
	}
	~littleGrey()
	{
	}
};

